/*

This program writes the GetNextPrime function to a SmartDongle using the demo keys.

Copyright 2010 MicroWorks, Inc.

   MicroWorks, Inc.
   2808 North Cole Road
   Boise, ID 83704
*/
#include <objbase.h>
#include <windows.h>
#include <setupapi.h>
#include <stdlib.h>
#include <time.h>
#include <ctype.h>

#include <stdio.h>
#include <stdlib.h>
#include "smartdongle.h"
#include "devioctl.h"
#include "usb100.h"
#include "sd_cy7c63743.h"
#include "sd_cp2.h"
#include "sd_user.h"
#include "sd_eeprom.h"
#include "sd_uskerr.h"
#include "sd_helper.h"

unsigned int GetNextPrime(unsigned int iParm)
  {
  unsigned int iNextTry;
  unsigned int iDivisor;
  unsigned int iQuotient;

  if (iParm < 2)
    return 2;
                 
  if (iParm & 1)
    { //If this is an odd number start with the next odd number
    iNextTry = iParm+2;
    }
  else
    { // add 1 to even numbers
    iNextTry = iParm+1;
    }

  if (iNextTry < iParm)
    { // number wrapped around
    return 0;
    }

  for (; iNextTry>1; iNextTry+=2)
    {
    for (iDivisor =3; ; iDivisor+=2)
      {
      iQuotient = iNextTry / iDivisor;
      if (iQuotient < iDivisor)
        { // We have tried all values less then the square root of iQuotient
          // without finding any that divide evently.  This means that iNextTry
          // is a prime
        return (iNextTry);
        }
      if (iQuotient * iDivisor == iNextTry)
        { // iQuotient and iDivisor are factors of iNextTry.
          // iNextTry is not a prime, try the next value
        break;
        }
      }
    }
  // Something bad happened.  There were no primes larger than the starting value
  return (0);
  }

int __cdecl main(int argc, char* argv[])
{
char * pAddress = (char *)&GetNextPrime;
int error;
unsigned __int64 P1, P2;
unsigned int iParm;
unsigned int iReturn;
unsigned int iSize = 83; //   79 for GetNextPrime

if (argc != 1)                                       
  {
  printf ("Usage:  WriteNext\n");
  return (1);
  }

iParm = 4294967295;
iReturn = GetNextPrime(iParm);
SmartDongleLedOff();
SmartDongleLedRed();
SmartDongleLedGreen();
P1 = 0xec6cc589aefd1e75;
P2 = 0xfcec0a6a82747b3f;
  
// Write the size of the function to the SmartDongle
error = SmartDongleWrite(P1, P2, 0, (char *)&iSize, 4);
if (error)
  {
  error = error;
  }
// Write the function to the SmartDongle
error = SmartDongleWrite(P1, P2, 4, (char *)&GetNextPrime, iSize);
if (error)
  {
  error = error;
  }
SmartDongleLedGreen();
return 0;
}
